## fcitx 4.2.8.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6)

project(fcitx)

set(version 4.2.8.3)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC_RELAXED_MODE TRUE)

set_property(GLOBAL PROPERTY "__FCITX_INTERNAL_BUILD" On)

option(ENABLE_X11 "Enable X11 as dependency" ON)
option(ENABLE_GLIB2 "Enable GLib2 as depenedency" ON)
option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_LIBXML2 "Enable libxml2" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_PINYIN "Enable Pinyin" ON)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT "Enable Qt-based lib" On)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" ON)
option(ENABLE_QT_GUI "Enable Qt-based configuration GUI" On)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(FORCE_OPENCC
  "Enable opencc even if the library is not found at compile time" Off)
option(ENABLE_LUA "Enable Lua support" OFF)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" On)
option(ENABLE_GIR "Enable GObject Introspection" On)
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_PRESAGE "Enable presage for word predication" On)
option(FORCE_ENCHANT
  "Enable enchant even if the library is not found at compile time" Off)
option(FORCE_PRESAGE
  "Enable presage even if the library is not found at compile time" Off)
option(ENABLE_ICU "Enable icu for qt/keyboard compose" On)
option(ENABLE_BACKTRACE "Enable backtrace support" On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installion" On)
option(ENABLE_GETTEXT "Enable gettext support." On)

if(NOT NO_SNOOPER_APPS)
  set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
    CACHE STRING "Disable Key Snooper for following app")
endif()

if(NOT NO_PREEDIT_APPS)
  set(NO_PREEDIT_APPS "gvim"
    CACHE STRING "Disable Preedit for the following apps")
endif()

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

_fcitx_add_uninstall_target()
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

find_package(Libintl REQUIRED)
find_package(Libiconv REQUIRED)
find_package(Pthread REQUIRED)
find_package(Libexecinfo)
find_package(GettextPo)

if(NOT ENABLE_GETTEXT OR NOT GETTEXTPO_FOUND)
  fcitx_disable_gettext()
endif()

if(LIBEXECINFO_LIB_FOUND)
  set(ENABLE_BACKTRACE 1)
else()
  set(ENABLE_BACKTRACE 0)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
  find_package(Libkvm REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
find_package(DL REQUIRED)
if(ENABLE_ENCHANT)
  find_package(Enchant)
  if(NOT (ENCHANT_FOUND OR FORCE_ENCHANT))
    set(ENABLE_ENCHANT Off)
  endif()
endif()
if (ENABLE_LIBXML2)
    find_package(LibXml2 REQUIRED)
    find_package(IsoCodes REQUIRED)
    find_package(XkbFile REQUIRED)
endif (ENABLE_LIBXML2)
if(ENABLE_PRESAGE)
  find_package(Presage)
  if(NOT (PRESAGE_FOUND OR FORCE_PRESAGE))
    set(ENABLE_PRESAGE Off)
  endif()
endif()
if(ENABLE_ICU)
  find_package(ICU REQUIRED)
endif()

if(ENABLE_QT)
  find_package(Qt4 4.5 COMPONENTS QtCore QtGui QtDBus REQUIRED)
endif()

if(ENABLE_X11)
find_package(X11 REQUIRED)

if (NOT X11_Xkb_FOUND)
    message(FATAL_ERROR "Xkb is needed")
endif (NOT X11_Xkb_FOUND)

find_program(some_x_program NAMES iceauth xrdb xterm)
if (NOT some_x_program)
    _pkgconfig_invoke("x11" PC_X11 PREFIX "" "--variable=prefix")
    if (PC_X11_PREFIX)
        set(some_x_program "${PC_X11_PREFIX}/bin/xrdb")
    else (PC_X11_PREFIX)
        set(some_x_program /usr/bin/xrdb)
        message("Warning: Could not determine X binary directory. Assuming /usr/bin.")
    endif (PC_X11_PREFIX)
endif (NOT some_x_program)
get_filename_component(proto_xbindir "${some_x_program}" PATH)
get_filename_component(XBINDIR "${proto_xbindir}" ABSOLUTE)
get_filename_component(xrootdir "${XBINDIR}" PATH)
set(XLIBDIR "${xrootdir}/lib/X11")
endif(ENABLE_X11)

if (ENABLE_TEST)
    ENABLE_TESTING()
endif (ENABLE_TEST)

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_X11 AND ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib>=1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_X11 AND ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO AND ENABLE_GLIB2)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo>=1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO AND ENABLE_GLIB2)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1>=1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

if(ENABLE_OPENCC)
    find_package(OpenCC)
    if(NOT (OPENCC_FOUND OR FORCE_OPENCC))
        set(ENABLE_OPENCC Off)
    endif()
endif()

set(HAVE_XINERAMA 0)
if (X11_Xinerama_FOUND)
    set(HAVE_XINERAMA 1)
endif (X11_Xinerama_FOUND)

if (X11_Xfixes_FOUND)
    set(HAVE_XFIXES 1)
endif (X11_Xfixes_FOUND)

if(ENABLE_DEBUG)
    set(_DEBUG ON)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR "${exec_prefix}/lib" CACHE PATH "Library install directory [default=PREFIX/lib/]")
endif()
if(NOT DEFINED LIBDATA_INSTALL_DIR)
    set(LIBDATA_INSTALL_DIR "${LIB_INSTALL_DIR}"  CACHE PATH "Lib data install directory [default=LIB_INSTALL_DIR]")
endif()
if(NOT DEFINED MAN_INSTALL_DIR)
    set(MAN_INSTALL_DIR "${prefix}/share/man"  CACHE PATH "man install directory [default=PREFIX/share/man]")
endif()
if (NOT DEFINED DBUS_SERVICE_DIR)
    set(DBUS_SERVICE_DIR "${CMAKE_INSTALL_PREFIX}/share/dbus-1/services" CACHE PATH "dbus session service directory [default=PREFIX/share/dbus-1/services]")
endif()
if (NOT DEFINED SYSCONFDIR)
    set(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "sys config directory [default=PREFIX/etc/]")
endif()

set(includedir "${CMAKE_INSTALL_PREFIX}/include")
set(libdir ${LIB_INSTALL_DIR})
set(pkgconfdir ${LIBDATA_INSTALL_DIR}/pkgconfig)
set(mandir ${MAN_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(imconfigdir ${pkgdatadir}/inputmethod)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

function(_RESOLVE_LIBRARY_PATH _FILE_NAME _LIBRARY_PATH)
    if (CMAKE_OBJDUMP)
        execute_process (
            COMMAND ${CMAKE_OBJDUMP} -p "${_LIBRARY_PATH}"
            RESULT_VARIABLE STATUS
            OUTPUT_VARIABLE OBJDUMP_RESULT
            ERROR_QUIET
        )
        string(REGEX REPLACE ".*SONAME +([^ ]+)\n.*$" "\\1" SONAME_OUT "${OBJDUMP_RESULT}")
        if (SONAME_OUT)
            set(_FILE_NAME_OUT "${SONAME_OUT}")
        endif ()
    endif()
    if (NOT _FILE_NAME_OUT)
        get_filename_component(_FILE_NAME_OUT "${_LIBRARY_PATH}" NAME)
    endif()
    set(${_FILE_NAME} ${_FILE_NAME_OUT} PARENT_SCOPE)
endfunction()


if (NOT DEFINED OPENCC_LIBRARY_FILENAME)
    if (OPENCC_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(OPENCC_LIBRARY_FILENAME "${OPENCC_LIBRARIES}")
    else ()
        set(OPENCC_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}opencc${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

if(NOT DEFINED ENCHANT_LIBRARY_FILENAME)
    if (ENCHANT_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(ENCHANT_LIBRARY_FILENAME "${ENCHANT_LIBRARIES}")
    else ()
        set(ENCHANT_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()
if(NOT DEFINED PRESAGE_LIBRARY_FILENAME)
    if (PRESAGE_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(PRESAGE_LIBRARY_FILENAME "${PRESAGE_LIBRARIES}")
    else ()
        set(PRESAGE_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/lib/)

# must be the first
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(cmake)

if(ENABLE_TEST)
  add_subdirectory(test)
endif()

=== data/CMakeLists.txt ===
add_subdirectory(script)
add_subdirectory(icon)

set(FCITX_DESC_FILES
  addon.desc
  config.desc
  profile.desc
  inputmethod.desc
  )

set(FCITX_DATA_FILES
  AutoEng.dat
  gbks2t.tab
  punc.mb.zh_CN
  punc.mb.zh_HK
  punc.mb.zh_TW
  vk.conf
  )

set(FCITX_PY_FILES
  pySym.mb
  sp.dat
  )

set(FCITX_DSEKTOP_FILES
  fcitx.desktop
  fcitx-configtool.desktop
  fcitx-autostart.desktop
  )

fcitx_translate_add_sources(
  fcitx-configtool.desktop.in
  fcitx.desktop.in
  fcitx-autostart.desktop.in)
fcitx_translate_add_apply_source(
  fcitx-configtool.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop")
fcitx_translate_add_apply_source(
  fcitx.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop")
fcitx_translate_add_apply_source(
  fcitx-autostart.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop")

add_custom_target(desktopfile ALL DEPENDS ${FCITX_DSEKTOP_FILES})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop"
  DESTINATION share/applications/)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop"
  DESTINATION share/applications/)

install(FILES ${FCITX_DATA_FILES} DESTINATION "${pkgdatadir}/data")
fcitx_install_addon_desc(${FCITX_DESC_FILES})

if(_ENABLE_DBUS AND ENABLE_XDGAUTOSTART)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop"
    DESTINATION "${SYSCONFDIR}/xdg/autostart")
endif()

if(_ENABLE_DBUS)
  install(FILES daemon.conf DESTINATION share/fcitx/dbus/)
endif()

=== po/CMakeLists.txt ===
set(PO_LANGS de es ja zh_CN zh_TW)
foreach(lang ${PO_LANGS})
  fcitx_translate_add_po_file("${lang}" "${lang}.po")
endforeach()
fcitx_translate_set_pot_target(pot fcitx fcitx.pot)

install(FILES getdescpo DESTINATION share/cmake/fcitx
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== data/icon/CMakeLists.txt ===
foreach(size 16 22 24 32 48 128)
    install(DIRECTORY ${size}x${size} DESTINATION share/icons/hicolor
             PATTERN .* EXCLUDE
             PATTERN *~ EXCLUDE)
endforeach(size 16 22 24 32 48 128)

install(DIRECTORY scalable DESTINATION share/icons/hicolor
         PATTERN ".*" EXCLUDE
         PATTERN "*~" EXCLUDE)

install(DIRECTORY symbolic/scalable DESTINATION share/icons/hicolor
         PATTERN ".*" EXCLUDE
         PATTERN "*~" EXCLUDE )

=== doc/man/CMakeLists.txt ===
set(FCITX_MANS
fcitx.1 createPYMB.1 readPYBase.1 readPYMB.1 mb2org.1 scel2org.1 mb2txt.1 txt2mb.1 fcitx-remote.1
)

install(FILES ${FCITX_MANS} DESTINATION "${mandir}/man1")

=== tools/gui/CMakeLists.txt ===
include_directories(
  ${QT_INCLUDE_DIR}
  ${QT_QTCORE_INCLUDE_DIR}
  ${QT_QTGUI_INCLUDE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  )


add_subdirectory(quickphrase-editor)
add_subdirectory(wrapper)

=== src/frontend/gtk2/CMakeLists.txt ===
set(FCITX_GTK2_IM_MODULE_GIO_SOURCES
  fcitxim.c
  fcitximcontext-gio.c
  )
set(FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES
  fcitxim.c
  fcitximcontext.c
  client.c
  )

fcitx_translate_add_sources(${FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES}
  ${FCITX_GTK2_IM_MODULE_GIO_SOURCES})

set(FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES
  ${FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES}
  "${CMAKE_CURRENT_BINARY_DIR}/marshall.c"
  "${CMAKE_CURRENT_BINARY_DIR}/marshall.h"
  )

if(NOT ENABLE_GTK2_IM_MODULE)
  return()
endif()

PKG_CHECK_MODULES(GTK2 REQUIRED "gtk+-2.0" )
_pkgconfig_invoke("gtk+-2.0" GTK2 BINARY_VERSION
  "" "--variable=gtk_binary_version")

if (NOT DEFINED GTK2_IM_MODULEDIR)
    set(GTK2_IM_MODULEDIR "${LIB_INSTALL_DIR}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules" CACHE PATH "Gtk2 im module directory")
endif()

include_directories(${GTK2_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK2_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
  COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)
add_custom_command(OUTPUT marshall.h
  COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)

if(GIO2_FOUND)
  include_directories(${GIO2_INCLUDE_DIRS})
  link_directories(${GIO2_LIBRARY_DIRS})

  set(FCITX_GTK2_IM_MODULE_SOURCES ${FCITX_GTK2_IM_MODULE_GIO_SOURCES})
else()
  include_directories(${DBUS_GLIB_INCLUDE_DIRS})
  link_directories(${DBUS_GLIB_LIBRARY_DIRS})

  set(FCITX_GTK2_IM_MODULE_SOURCES ${FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES})
endif()

add_library(im-fcitx MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
set_target_properties( im-fcitx PROPERTIES PREFIX ""
  COMPILE_FLAGS "-fvisibility=hidden" LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries(im-fcitx ${GTK2_LIBRARIES} fcitx-utils)
if(GIO2_FOUND)
  target_link_libraries(im-fcitx ${GTK2_LIBRARIES} ${GIO2_LIBRARIES}
    fcitx-gclient fcitx-utils)
else()
  target_link_libraries(im-fcitx ${GTK2_LIBRARIES} ${DBUS_GLIB_LIBRARIES}
    fcitx-utils)
endif()
install(TARGETS im-fcitx DESTINATION "${GTK2_IM_MODULEDIR}")

=== src/frontend/gtk3/CMakeLists.txt ===
if(NOT ENABLE_GTK3_IM_MODULE)
  return()
endif()
PKG_CHECK_MODULES(GTK3 REQUIRED "gtk+-3.0" )

_pkgconfig_invoke("gtk+-3.0" GTK3 BINARY_VERSION
  "" "--variable=gtk_binary_version")

if (NOT DEFINED GTK3_IM_MODULEDIR)
    set(GTK3_IM_MODULEDIR "${LIB_INSTALL_DIR}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules" CACHE PATH "Gtk3 im module directory")
endif()

include_directories(${GTK3_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK3_LIBRARY_DIRS})

if(GIO2_FOUND)
  include_directories(${GIO2_INCLUDE_DIRS})
  link_directories(${GIO2_LIBRARY_DIRS})

  set(FCITX_GTK3_IM_MODULE_SOURCES
    fcitxim.c
    fcitximcontext-gio.c)
else()
  include_directories(${DBUS_GLIB_INCLUDE_DIRS})
  link_directories(${DBUS_GLIB_LIBRARY_DIRS})

  add_custom_command(OUTPUT marshall.c
    COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
    ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)
  add_custom_command(OUTPUT marshall.h
    COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
    ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)

  set(FCITX_GTK3_IM_MODULE_SOURCES
    fcitxim.c
    fcitximcontext.c
    client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
    )
endif()

add_library(im-fcitx-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
set_target_properties( im-fcitx-gtk3 PROPERTIES PREFIX ""
  COMPILE_FLAGS "-fvisibility=hidden" OUTPUT_NAME "im-fcitx"
  LINK_FLAGS "-Wl,--no-undefined")

if(GIO2_FOUND)
  target_link_libraries(im-fcitx-gtk3 ${GTK3_LIBRARIES} ${GIO2_LIBRARIES}
    fcitx-gclient fcitx-utils)
else()
  target_link_libraries(im-fcitx-gtk3 ${GTK3_LIBRARIES}
    ${DBUS_GLIB_LIBRARIES} fcitx-utils)
endif()
install(TARGETS im-fcitx-gtk3 DESTINATION "${GTK3_IM_MODULEDIR}")

=== src/frontend/qt/CMakeLists.txt ===
set(qtim_fcitx_SRCS
  qfcitxinputcontextplugin.cpp
  qfcitxinputcontext.cpp
  )

fcitx_translate_add_sources(${qtim_fcitx_SRCS}
  keyserver_x11.h
  qfcitxinputcontext.h
  )

if(NOT (ENABLE_QT_IM_MODULE AND ENABLE_QT))
  return()
endif()

include_directories(
  ${QT_INCLUDE_DIR}
  ${QT_QTCORE_INCLUDE_DIR}
  ${QT_QTGUI_INCLUDE_DIR}
  ${QT_QTDBUS_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

if(ENABLE_X11)
  include_directories(${X11_INCLUDE_DIRS})
  link_directories(${X11_LIBRARY_DIRS})
endif()

set(qtim_fcitx_MOC_HDRS
  qfcitxinputcontext.h
  )

QT4_AUTOMOC(${qtim_fcitx_SRCS})
QT4_WRAP_CPP(qtim_fcitx_MOC_SRCS
  ${qtim_fcitx_MOC_HDRS}
  )

add_library(
  qtim-fcitx MODULE
  ${qtim_fcitx_SRCS}
  ${qtim_fcitx_MOC_SRCS}
  )

set_target_properties(qtim-fcitx PROPERTIES
  PREFIX ""
  COMPILE_FLAGS "-fvisibility=hidden"
  LINK_FLAGS "-Wl,--no-undefined")

target_link_libraries(
  qtim-fcitx
  debug ${QT_QTCORE_LIBRARY_DEBUG}
  debug ${QT_QTDBUS_LIBRARY_DEBUG}
  debug ${QT_QTGUI_LIBRARY_DEBUG}
  optimized ${QT_QTCORE_LIBRARY_RELEASE}
  optimized ${QT_QTDBUS_LIBRARY_RELEASE}
  optimized ${QT_QTGUI_LIBRARY_RELEASE}
  fcitx-config
  fcitx-qt
  )

if(ENABLE_X11)
  target_link_libraries(qtim-fcitx ${X11_LIBRARIES})
endif()

install(
  TARGETS qtim-fcitx
  LIBRARY DESTINATION
  "${QT_PLUGINS_DIR}/inputmethods")

=== src/im/keyboard/CMakeLists.txt ===
include_directories (
  ${LIBINTL_INCLUDE_DIR}
  ${LIBICONV_INCLUDE_DIR}
  )
set(FCITX_KEYBOARD_LINK_LIBS ${LIBICONV_LIBRARIES})
if(ENABLE_ICU)
  include_directories(${ICU_INCLUDE_DIRS})
  set(FCITX_KEYBOARD_LINK_LIBS ${FCITX_KEYBOARD_LINK_LIBS} ${ICU_LIBRARIES})
endif()
if(ENABLE_LIBXML2)
  include_directories(${LIBXML2_INCLUDE_DIR})
  set(FCITX_KEYBOARD_LINK_LIBS ${FCITX_KEYBOARD_LINK_LIBS} ${LIBXML2_LIBRARIES})
endif()

set(FCITX_KEYBOARD_SOURCES
  keyboard.c
  keyboardconfig.c
  )

if(ENABLE_LIBXML2)
  set(FCITX_KEYBOARD_SOURCES ${FCITX_KEYBOARD_SOURCES} isocodes.c)
endif()

fcitx_add_addon_full(keyboard DESC
  SOURCES ${FCITX_KEYBOARD_SOURCES}
  LINK_LIBS ${FCITX_KEYBOARD_LINK_LIBS}
  EXTRA_PO isocodes.c isocodes.h fcitx-compose-data.h keyboard.h)

=== src/module/quickphrase/CMakeLists.txt ===
set(FCITX_QUICKPHRASE_SOURCES
  quickphrase.c)

fcitx_add_addon_full(quickphrase SCAN SCAN_PRIV DESC
  SOURCES ${FCITX_QUICKPHRASE_SOURCES}
  HEADERS quickphrase.h)
  
install(DIRECTORY quickphrase.d DESTINATION "${pkgdatadir}/data"
         PATTERN ".*" EXCLUDE
         PATTERN "*~" EXCLUDE)

=== tools/gui/quickphrase-editor/CMakeLists.txt ===
set(QUICKPHRASE_EDITOR_SRCS 
  main.cpp
  model.cpp
  editor.cpp
  editordialog.cpp
  batchdialog.cpp
  filelistmodel.cpp
  )
fcitx_translate_add_sources(
  ${QUICKPHRASE_EDITOR_SRCS})

if(NOT (ENABLE_QT AND ENABLE_QT_GUI))
  return()
endif()

include_directories(
  ${QT_QTCORE_INCLUDE_DIR}
  ${QT_QTGUI_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  )
qt4_wrap_ui(QUICKPHRASE_EDITOR_SRCS editordialog.ui batchdialog.ui editor.ui)
add_library(fcitx-quickphrase-editor
  MODULE ${QUICKPHRASE_EDITOR_SRCS})

set_target_properties(fcitx-quickphrase-editor PROPERTIES
                      LINK_FLAGS "-Wl,--no-undefined"
                      AUTOMOC TRUE
)
target_link_libraries(fcitx-quickphrase-editor
  debug ${QT_QTCORE_LIBRARY_DEBUG}
  debug ${QT_QTDBUS_LIBRARY_DEBUG}
  debug ${QT_QTGUI_LIBRARY_DEBUG}
  optimized ${QT_QTCORE_LIBRARY_RELEASE}
  optimized ${QT_QTDBUS_LIBRARY_RELEASE}
  optimized ${QT_QTGUI_LIBRARY_RELEASE}
  fcitx-utils
  fcitx-config
  fcitx-qt
  )

install(TARGETS fcitx-quickphrase-editor DESTINATION ${libdir}/fcitx/qt)

=== debian/changelog ===
fcitx (1:4.2.8.3-3) unstable; urgency=low

  * debian/patches/0004-add-a-context-variable-to-disable-punc.patch:
    - Add a context variable to disable punc module.
  * std-ver: 3.9.4 -> 3.9.5, no change required.

 -- Aron Xu <aron@debian.org>  Tue, 11 Mar 2014 00:16:41 +0800

fcitx (1:4.2.8.3-2) unstable; urgency=low

  * fcitx-modules Breaks and Replaces
     fcitx-module-quickphrase-editor (<< 1:4.2.8.3) (Closes: #729706)

 -- YunQiang Su <wzssyqa@gmail.com>  Sun, 17 Nov 2013 17:25:30 +0800

fcitx (1:4.2.8.3-1) unstable; urgency=low

  * New upstream bugfix release.

 -- Aron Xu <aron@debian.org>  Fri, 15 Nov 2013 14:31:20 +0800

=== debian/control ===
Source: fcitx
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
Build-Depends: debhelper (>= 9), cmake, liblua5.2-dev | liblua5.1-0-dev,
    libdbus-1-dev (>= 1.1.0), libpango1.0-dev (>= 1.0), libcairo2-dev (>= 1.0),
    libopencc-dev (>= 0.1.1~), libicu-dev, x11proto-xinerama-dev,
    libgtk2.0-dev, libqt4-dev, libgtk-3-dev, libkvm-dev [kfreebsd-any],
    libenchant-dev, libpresage-dev, libxml2-dev, libxkbfile-dev, gobject-introspection,
    libgirepository1.0-dev, iso-codes, libxfixes-dev, libpthread-stubs0-dev, libgettextpo-dev
Standards-Version: 3.9.5
Homepage: http://code.google.com/p/fcitx/
Vcs-Git: git://anonscm.debian.org/pkg-ime/fcitx.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/fcitx.git

Package: fcitx
Architecture: all
Depends: ${misc:Depends}, fcitx-bin, fcitx-data, fcitx-modules
Recommends: fcitx-config-gtk | kde-config-fcitx,
    fcitx-frontend-all | fcitx-frontend-fbterm,
    fcitx-ui-classic | fcitx-ui-light,
    im-config (>= 0.5) | im-switch
Suggests: fcitx-tools, fcitx-m17n
Description: Flexible Input Method Framework
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - essential binaries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package 
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - essential data files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx-libs-gclient, fcitx-libs-qt
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - library files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains three libraries:
  * libfcitx-core - core functions of Fcitx
  * libfcitx-config - support library for Fcitx configurations
  * libfcitx-utils - utility support library for Fcitx

Package: fcitx-libs-gclient
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-libs
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.7)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.7)
Description: Flexible Input Method Framework - D-Bus client library for Glib
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-gclient - D-Bus client library for Glib

Package: fcitx-libs-qt
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-libs
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - D-Bus client library for Qt
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-qt - D-Bus client library for Qt

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, fcitx-bin (= ${binary:Version}), fcitx-libs (= ${binary:Version}),
 fcitx-libs-gclient (= ${binary:Version}), fcitx-libs-qt (= ${binary:Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Recommends: fcitx-bin (>= ${source:Upstream-Version})
Description: Flexible Input Method Framework - library development files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: gir1.2-fcitx-1.0
Architecture: any
Section: introspection
Depends: ${gir:Depends}, ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - GObject introspection 
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings.

Package: fcitx-dbg
Architecture: any
Section: debug
Priority: extra
Multi-Arch: same
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - debugging symbols
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the debugging symbols of the whole Fcitx.

Package: fcitx-ui-classic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-x11
Recommends: fcitx (>= ${source:Upstream-Version}), zenity
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-unikey (<< 0.2.0), fcitx-hangul (<< 0.3.0)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-unikey (<< 0.2.0), fcitx-hangul (<< 0.3.0)
Description: Flexible Input Method Framework - Classic user interface
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the classic user interface, which is suitable 
 for most users. It also provides the following skins:
  * classic: Fcitx 3.x classic skin ported to new infrastructure
  * dark: the dark skin fits for dark desktop theme
  * default: the default skin

Package: fcitx-frontend-all
Architecture: all
Depends: ${misc:Depends}
Recommends: fcitx-frontend-gtk2, fcitx-frontend-gtk3, fcitx-frontend-qt4
Description: Flexible Input Method Framework - frontends metapackage
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in the following frontends:
  * XIM protocol client
  * GTK+ 2/3 IM Module
  * QT 4 IM Module

Package: fcitx-frontend-gtk2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk3
Description: Flexible Input Method Framework - GTK+ 2 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications

=== debian/rules ===
#!/usr/bin/make -f
include debian/variables.mk
include debian/gencontrol.mk
%:
	dh $@ --with gir
override_dh_auto_clean: gen_control
	dh_auto_clean
override_dh_auto_configure: gen_control
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	    -DSYSCONFDIR=/etc \
	    -DENABLE_X11=ON \
	    -DENABLE_GLIB2=ON \
	    -DENABLE_CAIRO=ON \
	    -DENABLE_DBUS=ON \
	    -DENABLE_PANGO=ON \
	    -DENABLE_LIBXML2=ON \
	    -DENABLE_DEBUG=OFF \
	    -DENABLE_PINYIN=ON \
	    -DENABLE_TABLE=ON \
	    -DENABLE_GTK2_IM_MODULE=ON \
	    -DENABLE_GTK3_IM_MODULE=ON \
	    -DENABLE_QT=ON \
	    -DENABLE_QT_IM_MODULE=ON \
	    -DENABLE_QT_GUI=ON \
	    -DENABLE_OPENCC=ON \
	    -DENABLE_LUA=ON \
	    -DENABLE_STATIC=ON \
	    -DENABLE_TEST=ON \
	    -DENABLE_SNOOPER=ON \
	    -DENABLE_GIR=ON \
	    -DENABLE_ENCHANT=ON \
	    -DENABLE_PRESAGE=ON \
	    -DENABLE_ICU=ON \
	    -DENABLE_BACKTRACE=ON \
	    -DENABLE_XDGAUTOSTART=ON \
	    -DENABLE_GETTEXT=ON
override_dh_install:
	dh_install --fail-missing
override_dh_makeshlibs:
	dh_makeshlibs -pfcitx-libs
	dh_makeshlibs -pfcitx-libs-gclient
	dh_makeshlibs -pfcitx-libs-qt
override_dh_strip:
	dh_strip --dbg-package=fcitx-dbg

## fcitx 4.2.8.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(fcitx)
 
-set(version 4.2.8.3)
+set(version 4.2.8.4)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 set(CMAKE_AUTOMOC_RELAXED_MODE TRUE)
